﻿Public Class Form1
    Dim X As Integer = 0
    Dim A(100) As String

    Private Sub btnBubble_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBubbleDown.Click
        tmrSort.Start()
        Dim I, J, K As Integer
        Dim N As Integer = lstSort.Items.Count
        For K = 0 To N - 1
            A(K) = lstSort.Items.Item(K)
        Next K
        For I = N To 0 Step -1
            For J = I To N - 1
                If A(J) < A(J + 1) Then
                    Swap(J + 1, J, A(J), A(J + 1))
                End If
            Next J
        Next (I)
        tmrSort.Stop()
        MsgBox("Bubble Down Time taken = " & X, MsgBoxStyle.Critical)
        Form1_Load(Me, New System.EventArgs)
    End Sub
    Private Sub Swap(ByRef L As Integer, ByVal M As Integer, ByRef small As String, ByRef large As String)
        Dim temp As String = small
        A(M) = large
        lstSort.Items.Item(M) = A(M)
        A(L) = temp
        lstSort.Items.Item(L) = A(L)
    End Sub
    
    
    Private Sub btnBubbleUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBubbleUp.Click

        tmrSort.Start()
        Dim I, J, K As Integer
        Dim N As Integer = lstSort.Items.Count
        For K = 0 To N - 1
            A(K) = lstSort.Items.Item(K)
        Next K
        For I = 0 To N - 1
            For J = 0 To N - 2
                If A(J) > A(J + 1) Then
                    Swap(J + 1, J, A(J), A(J + 1))
                End If
            Next J
        Next (I)

        MsgBox("Bubble Up Time taken = " & X, MsgBoxStyle.Critical)
        Form1_Load(Me, New System.EventArgs)
    End Sub

    Private Sub SelectionSort()
        Dim I, J, K As Integer
        Dim N As Integer = lstSort.Items.Count
        For K = 0 To N - 1
            A(K) = lstSort.Items.Item(K)
        Next K
        Dim large, max_pos As String
        For I = 0 To N - 1
            large = A(I)
            max_pos = I
            For J = N - 1 To I + 1 Step -1
                If A(J) > large Then
                    Swap(J, I, A(I), A(J))
                    SelectionSort()
                    Exit Sub
                End If
            Next J
        Next I



    End Sub

    Private Sub btnSelection_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelection.Click

        tmrSort.Start()
        SelectionSort()
        MsgBox("Selection Time taken = " & X, MsgBoxStyle.Critical)
        Form1_Load(Me, New System.EventArgs)

    End Sub

    Private Sub tmrSort_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrSort.Tick
        X = X + 1
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lstSort.Items.Clear()
        lstSort.Items.Add("Rabbit")
        lstSort.Items.Add("Oxen")
        lstSort.Items.Add("Snake")
        lstSort.Items.Add("Dove")
        lstSort.Items.Add("Zebra")
        lstSort.Items.Add("Eagle")
        lstSort.Items.Add("Dog")
        lstSort.Items.Add("Fox")
        lstSort.Items.Add("Gorilla")
        lstSort.Items.Add("Platypus")
        tmrSort.Enabled = True
        X = 0

    End Sub

    Private Sub btnInsertion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInsertion.Click

        tmrSort.Start()
        Dim I, J, K As Integer
        Dim N As Integer = lstSort.Items.Count
        For K = 0 To N - 1
            A(K) = lstSort.Items.Item(K)
        Next K
        For I = N - 1 To 1 Step -1
            J = I - 1
            Do While J > -1
                If A(J) > A(I) Then
                    Swap(J, I, A(I), A(J))
                End If
                J = J - 1
            Loop
        Next I

        MsgBox("Insertion Time taken = " & X, MsgBoxStyle.Critical)
        Form1_Load(Me, New System.EventArgs)

    End Sub

    Public Sub Quicksort(ByVal list() As String, ByVal min As Integer, ByVal max As Integer)
        tmrSort.Start()
        Dim N As Integer = lstSort.Items.Count
        Dim random_number As New Random
        Dim med_value As String
        Dim hi As Integer
        Dim lo As Integer
        Dim i As Integer

        ' If min >= max, the list contains 0 or 1 items so
        ' it is sorted.
        If min >= max Then Exit Sub

        ' Pick the dividing value.
        i = random_number.Next(min, max + 1)
        med_value = list(i)

        ' Swap it to the front.
        list(i) = list(min)

        lo = min
        hi = max
        Do
            ' Look down from hi for a value < med_value.
            Do While list(hi) >= med_value
                hi = hi - 1
                If hi <= lo Then Exit Do
            Loop
            If hi <= lo Then
                list(lo) = med_value
                Exit Do
            End If

            ' Swap the lo and hi values.
            list(lo) = list(hi)

            ' Look up from lo for a value >= med_value.
            lo = lo + 1
            Do While list(lo) < med_value
                lo = lo + 1
                If lo >= hi Then Exit Do
            Loop
            If lo >= hi Then
                lo = hi
                list(hi) = med_value
                Exit Do
            End If

            ' Swap the lo and hi values.
            list(hi) = list(lo)
        Loop

        ' Sort the two sublists.
        Quicksort(list, min, lo - 1)
        Quicksort(list, lo + 1, max)
        'MsgBox("sorted", MsgBoxStyle.Critical)
        lstSort.Items.Clear()
        For K = 0 To N - 1
            lstSort.Items.Add(A(K))
        Next K
    End Sub
    Private Sub btnQuick_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnQuick.Click
        Dim N As Integer = lstSort.Items.Count
        For K = 0 To N - 1
            A(K) = lstSort.Items.Item(K)
        Next K
        Quicksort(A, 0, N - 1)
        MsgBox("Quick Time taken = " & X, MsgBoxStyle.Critical)
        Form1_Load(Me, New System.EventArgs)
    End Sub
    Private Sub MergeSort(ByVal A() As String, ByVal low As Integer, ByVal high As Integer)
        Dim N As Integer = lstSort.Items.Count
        If low >= high Then Return
        Dim length As Integer = high - low + 1
        Dim middle As Integer = Math.Floor((low + high) / 2)
        MergeSort(A, low, middle)
        MergeSort(A, middle + 1, high)
        Dim temp(A.Length - 1) As String
        For i As Integer = 0 To length - 1
            temp(i) = A(low + i)
        Next
        Dim m1 As Integer = 0
        Dim m2 As Integer = middle - low + 1
        For i As Integer = 0 To length - 1
            If m2 <= high - low Then
                If m1 <= middle - low Then
                    If temp(m1) > temp(m2) Then
                        A(i + low) = temp(m2)
                        m2 += 1
                    Else
                        A(i + low) = temp(m1)
                        m1 += 1
                    End If
                Else

                    A(i + low) = temp(m2)
                    m2 += 1
                End If
            Else
                A(i + low) = temp(m1)
                m1 += 1
            End If
        Next
        lstSort.Items.Clear()
        For K = 0 To N - 1
            lstSort.Items.Add(A(K))
        Next K
    End Sub

    
    Private Sub btnMerge_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMerge.Click
        Dim N As Integer = lstSort.Items.Count
        For K = 0 To N - 1
            A(K) = lstSort.Items.Item(K)
        Next K
        MergeSort(A, 0, N - 1)
        MsgBox("Merge Time taken = " & X, MsgBoxStyle.Critical)
        Form1_Load(Me, New System.EventArgs)
    End Sub
End Class
